// rezswitch.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "change.h"
#include <conio.h>
#include <process.h>

class Resolution
{
public:
	Resolution() {nWidth=640; nHeight=480; nDepth=8; sRunnable=NULL;}
	
	Resolution(int width, int height, int depth)
	{
		setResolution(width, height, depth);
		sRunnable=NULL;
	}

	~Resolution()
	{
		delete[] sRunnable;
	}

	void setResolution(int width, int height, int depth)
	{
		nWidth	= width;
		nHeight = height;
		nDepth	= depth;
		sRunnable = NULL;
	}

	void changeResolution()
	{
		resManager.ChangeRes(nWidth, nHeight, nDepth);
	}
	
	void RestoreResolution()
	{
		resManager.RestoreResolution();
	}

	void setRunnable(char* filename)
	{
		sRunnable = new char[strlen(filename)+1];
		strcpy(sRunnable, filename);
	}

	void setWidth(char *width) 
	{
		nWidth = atoi(width);
	}
	
	void setHeight(char *height)
	{
		nHeight = atoi(height);
	}
	
	void setDepth(char *depth)
	{
		nDepth = atoi(depth);
	}

	int getWidth() {return (nWidth);}
	
	int getHeight() {return (nHeight);}
	
	int getDepth() {return(nDepth);}

	char* getRunnable() {return(sRunnable);}

private:
	int nWidth;
	int nHeight;
	int nDepth;
	char* sRunnable;
	ResManager resManager;
};

Resolution* GetResolution(int argc, char* argv[])
{
	Resolution* tempres = new Resolution();

	for (int i=0; i< argc; i++)
	{
		// Look for Runnable File
		if ( (strstr( argv[i], "-r") != NULL) || (strstr(argv[i], "-R") != NULL)  )
		{
			tempres->setRunnable(argv[i]+2);
		}

		// Look for the Width
		if ( (strstr( argv[i], "-w") != NULL) || (strstr( argv[i], "-W") != NULL) )
		{
			tempres->setWidth(argv[i]+2);	
		}

		// Look for the Height
		if ( (strstr( argv[i], "-h") != NULL) || (strstr( argv[i], "-H") != NULL) )
		{
			tempres->setHeight(argv[i]+2);
		}

		// Look for the BitDepth
		if ( (strstr( argv[i], "-b") != NULL) || (strstr( argv[i], "-B") != NULL) )
		{
			tempres->setDepth(argv[i]+2);
		}
	}

	return (tempres);
}

int main(int argc, char* argv[])
{

	Resolution* cResolution;

	cResolution = GetResolution(argc, argv);

	cResolution->changeResolution();
	
	_spawnlp(_P_WAIT,cResolution->getRunnable(),cResolution->getRunnable(), NULL); 

	cResolution->RestoreResolution();

	delete cResolution;
	return 0;
}
